var NoiseModule = null;
// export let vad_detector;
var {
    Module
} = require('./augnet.js');
var {
    featureStates
} = require('./conductor.js');
var sampleRate, inputBuffer = [],
    outputBuffer = [],
    bufferSize = 512;

function createBufferNodes(e, o) {
    return sampleRate = e.sampleRate, e.createScriptProcessor(bufferSize, 1, 1)
}
var denoise = function(e, o) {
    o = createBufferNodes(e, o);
    // console.log("denoise created buffer nodes")
    let t = [];
    return o.onaudioprocess = function(e) {
        var o = e.inputBuffer.getChannelData(0),
            u = e.outputBuffer.getChannelData(0);
        for (let e = 0; e < bufferSize; e++) inputBuffer.push(o[e]);
        for (; inputBuffer.length >= 480;) {
            for (let e = 0; e < 480; e++) t[e] = inputBuffer.shift();
            // console.log("suppress noise: ", featureStates.suppressNoise)
            featureStates.suppressNoise && removeNoise(t);

            for (let e = 0; e < 480; e++) outputBuffer.push(t[e])
        }
        if (!(outputBuffer.length < bufferSize))
        // console.log("DENOISING")
            for (let e = 0; e < bufferSize; e++) u[e] = outputBuffer.shift()
    }, o
}

function removeNoise(e) {
    let o = NoiseModule.ptr,
        t = NoiseModule.st;
    for (let t = 0; t < 480; t++) NoiseModule.HEAPF32[(o >> 2) + t] = 32768 * e[t];
    vad_detector = NoiseModule._augnet_process_frame(t, o, o);
    for (let t = 0; t < 480; t++) e[t] = NoiseModule.HEAPF32[(o >> 2) + t] / 32768
}
var initializeNoiseSuppressionModule = function() {
    NoiseModule ? console.log("Module already created") : (console.log("Setting up module from native c modules"), NoiseModule = {
        noExitRuntime: !0,
        noInitialRun: !0,
        preInit: [],
        preRun: [],
        postRun: [function() {
            console.log("Loaded Javascript Module OK")
        }],
        memoryInitializerPrefixURL: "bin/",
        arguments: ["input.ivf", "output.raw"]
    }, NoiseModule = Module, NoiseModule.st = NoiseModule._augnet_create(), NoiseModule.ptr = NoiseModule._malloc(1920))
}

module.exports = { NoiseModule, initializeNoiseSuppressionModule, denoise }